100 REMark   ***************************************************
110 REMark
120 REMark       SortBack, written by DILWYN JONES, 1991/92.
130 REMark
140 REMark     SortBack makes a backup copy with the option of
150 REMark      sorting the filenames into alphabetical order
160 REMark         and selective (Y/N/A/Q) file copy option
170 REMark
180 REMark        FREEWARE - please feel free to give copies
190 REMark             to other QL users if you like
200 REMark
210 REMark   ***************************************************
220 :
230 REMark $$asmb=flp1_qlib_ext,0,12
240 :
250 INITIALISE_ARRAYS
260 INITIALISE_DISPLAY
270 :
280 REPeat program
290   REMark ask for source and destination
300   INPUT #0,'Enter the source (e.g. mdv1_):';source$
310   INPUT #0,'Enter directory / wildcard   :';wcard$
320   INPUT #0,'Enter destination(e.g. mdv2_):';dest$
330   :
340   REMark read directory of specified device
350   PRINT #0,'Reading ';source$ & wcard$;'...';
360   REMark use DIR to a PIPE device
370   Q_ERR_ON 'open','q_pipe' : REMark error trap to reasonable extent
380   OPEN #4,'PIPE_10240'
390   error_type% = Q_ERR : REMark any error detected?
400   IF error_type% < 0 THEN
410     REMark oops, yes!
420     PRINT#0,\'PIPE error: ';
430     REPORT_AN_ERROR error_type%
440     IF WAIT$ = CHR$(27) THEN EXIT program
450     NEXT program
460   END IF
470   Q_PIPE #4 TO #3 : REMark join other end of pipe to same job
480   error_type% = Q_ERR : REMark any error detected?
490   IF error_type% < 0 THEN
500     REMark oops, yes!
510     PRINT #0,\'PIPE error: ';
520     REPORT_AN_ERROR error_type%
530     IF WAIT$ = CHR$(27) THEN EXIT program
540     NEXT program
550   END IF
560   Q_ERR_OFF 'open','q_pipe'
570   Q_ERR_ON 'dir'
580   DIR #4,source$ & wcard$
590   error_type% = Q_ERR : REMark any error detected?
600   IF error_type% < 0 THEN
610     REMark oops, yes!
620     PRINT #0, : REMark ensure error report is printed on a newline
630     REPORT_AN_ERROR error_type%
640     IF WAIT$ = CHR$(27) THEN EXIT program
650     NEXT program
660   END IF
670   REMark finished with that end of the pipe, so close it
680   REMark to ensure an EOF check at the other end will work
690   CLOSE #4
700   Q_ERR_OFF 'dir'
710   REMark remove unused information
720   INPUT #3,mdname$ : REMark medium name
730   INPUT #3,md_cap$ : REMark medium capacity
740   number% = 0 : REMark the number of filenames in table
750   REPeat loop
760     IF EOF(#3) : EXIT loop
770     INPUT #3,table$(number%)
780     tl% = LEN(table$(number%))
790     IF tl% > 2 THEN
800       IF table$(number%,tl% - 2 TO tl%) = ' ->' THEN
810         REMark could be a hard directory
820         NEXT loop
830       END IF
840     END IF
850     number% = number% + 1 : REMark one more filename!
860   END REPeat loop
870   CLOSE #3
880   PRINT #0,' (';number%;' files)'
890   IF number% = 0 THEN EXIT program
900   PRINT#0,\'Sort filenames Y/N? ';
910   sorted% = YN%
920   IF sorted% THEN SORT_ALPHA
930   CLS #0
940   PRINT #0,'Copying'!source$!'to'!dest$!'...'
950   Q_ERR_ON 'copy','delete'
960   ynaq_val%  = 0 : REMark 0 = no, 1 = yes, 2 = all, 3 = quit
970   overwrite% = 2 : REMark 0 to 3, as above
980   FOR a = 0 TO number% - 1
990     REMark copy all files one by one
1000     IF ynaq_val% < 2 THEN
1010       REMark not ALL, so need to prompt
1020       PRINT #0,'Copy ';table$(ind%(a));' Y/N/A/Q? ';
1030       ynaq_val% = YNAQ% : IF ynaq_val% = 0 THEN NEXT a : EXIT a
1040     ELSE
1050       REMark doing ALL, just print filename up
1060       IF ynaq_val% = 2 THEN
1070         PRINT#0,table$(ind%(a))
1080         IF INKEY$ = CHR$(27) THEN ynaq_val% = 3 : REMark quit
1090       END IF
1100     END IF
1110     IF ynaq_val% = 3 THEN EXIT a
1120     REMark try to backup the file
1130     COPY source$ & table$(ind%(a)) TO dest$ & table$(ind%(a))
1140     error_type% = Q_ERR
1150     IF error_type% < 0 THEN
1160       IF error_type% = -8 THEN
1170         IF overwrite% <> 2 THEN
1180           PRINT#0,'Already exists. Overwrite Y/N/A/Q? ';
1190           overwrite% = YNAQ%
1200           IF overwrite% = 3 THEN ynaq_val% = 3 : EXIT a
1210         END IF
1220         IF overwrite% = 0 THEN NEXT a : EXIT a
1230         DELETE dest$ & table$(ind%(a))
1240         COPY source$ & table$(ind%(a)) TO dest$ & table$(ind%(a))
1250       ELSE
1260         REPORT_AN_ERROR error_type%
1270       END IF
1280     END IF
1290   END FOR a
1300   EXIT program
1310 END REPeat program
1320 PRINT#0,'PROGRAM FINISHED, PRESS ANY KEY. ';
1330 Q_CURSON #0 : PAUSE : PRINT#0, : Q_CURSOFF #0
1340 Q_ERR_OFF
1350 STOP
1360 :
1370 REMark this procedure sorts and array called table$()
1380 REMark indexed by an array called ind%()
1390 REMark so each array entry is accessed as table$(ind%(number%))
1400 REMark unsorted array still available by resetting ind%() or by
1410 REMark accessing table$ without using ind%()
1420 :
1430 DEFine PROCedure SORT_ALPHA (sam%)
1440   LOCal x,y,a,swp,num%,highest%,intvl%
1450   IF number% < 2 THEN RETurn
1460   PRINT #0,'Sorting...'
1470   highest% = number% - 1
1480   num% = number% - 1
1490   REPeat swp
1500     num% = num% DIV 2 : IF num% < 1 THEN num% = 1
1510     FOR y = 0 TO num%
1520       intvl% = y+num%
1530       FOR x = intvl% TO highest% STEP num%
1540         swp = ind%(x)
1550         FOR a = x TO intvl% STEP -num%
1560           ind%(a) = ind%(a - num%)
1570           IF table$(swp) > table$(ind%(a)) THEN ind%(a) = swp:EXIT a
1580         END FOR a
1590         IF table$(swp) < table$(ind%(y)) THEN ind%(y) = swp
1600       END FOR x
1610     END FOR y
1620     IF num% < 2 THEN EXIT swp
1630   END REPeat swp
1640 END DEFine SORT_ALPHA
1650 :
1660 DEFine PROCedure INITIALISE_ARRAYS
1670   DIM table$(480,36) : REMark the filenames on the disk
1680   DIM ind%(480)      : REMark the index array
1690   REMark set default index
1700   FOR a = 0 TO 480   : ind%(a) = a
1710   number% = 0        : REMark 0 entries at the moment
1720 END DEFine INITIALISE_ARRAYS
1730 :
1740 DEFine PROCedure INITIALISE_DISPLAY
1750   IF (PEEK(163840+52)&& 8)=8 THEN MODE 4
1760   IF Q_MYJOB <> 0 THEN OPEN #0,'con' : OPEN #1,'scr': REMark for QRAM
1770   WINDOW #0,432,82,40,112
1780   WINDOW 448,104,32,96   : REMark cover whole area
1790   BORDER 1,0 : PAPER 7 : INK 0 : CLS
1800   BLOCK 39*6,14,105,1,4,7,1
1810   PAPER 7 : CURSOR 21*6,2
1820   PRINT' SortBack, by Dilwyn Jones, 1991 '
1830   INK    #0,7 : PAPER #0,0 : BORDER #0,1,4 : CLS #0
1840 END DEFine INITIALISE_DISPLAY
1850 :
1860 DEFine FuNction YNAQ%
1870   LOCal loop,k$(2),response%
1880   Q_CURSON #0
1890   REPeat loop
1900     k$ = INKEY$(-1)
1910     response% = k$ INSTR 'NYAQ'
1920     IF response% > 0 THEN PRINT #0,k$ : EXIT loop
1930   END REPeat loop
1940   Q_CURSOFF #0
1950   RETurn response% - 1 : REMark range from 0 to 3 returned
1960 END DEFine YNAQ%
1970 :
1980 DEFine FuNction YN%
1990   LOCal loop,k$(2),response%
2000   Q_CURSON #0
2010   REPeat loop
2020     k$ = INKEY$(-1)
2030     response% = k$ INSTR 'NY'
2040     IF response% > 0 THEN PRINT #0,k$ : EXIT loop
2050   END REPeat loop
2060   RETurn response% - 1 : REMark returns a value of 0 or 1
2070 END DEFine YN%
2080 :
2090 DEFine FuNction WAIT$
2100   LOCal k$(2)
2110   PRINT#0,'Press any key to continue. ';
2120   Q_CURSON #0 : k$ = INKEY$(-1)
2130   IF k$ = CHR$(27) THEN PRINT #0,'<ESC>' : ELSE PRINT #0, : END IF
2140   Q_CURSOFF #0 : RETurn k$
2150 END DEFine WAIT$
2160 :
2170 DEFine PROCedure REPORT_AN_ERROR (errtype%)
2180   LOCal error_value
2190   error_value = errtype%
2200   SELect ON error_value
2210     = -1  : PRINT #0,'Not complete.'
2220     = -2  : PRINT #0,'Invalid job.'
2230     = -3  : PRINT #0,'Out of memory.'
2240     = -4  : PRINT #0,'Out of range.'
2250     = -5  : PRINT #0,'Buffer overflow.'
2260     = -6  : PRINT #0,'Channel not open.'
2270     = -7  : PRINT #0,'Not found.'
2280     = -8  : PRINT #0,'Already exists.'
2290     = -9  : PRINT #0,'In use.'
2300     = -10 : PRINT #0,'End of file.'
2310     = -11 : PRINT #0,'Drive full.'
2320     = -12 : PRINT #0,'Bad name.'
2330     = -13 : PRINT #0,'Transmission error.'
2340     = -14 : PRINT #0,'Format failed.'
2350     = -15 : PRINT #0,'Bad parameter.'
2360     = -16 : PRINT #0,'Bad or changed medium.'
2370     = -17 : PRINT #0,'Error in expression.'
2380     = -18 : PRINT #0,'Arithmetic overflow.'
2390     = -19 : PRINT #0,'Not implemented.'
2400     = -20 : PRINT #0,'Read only.'
2410     = -21 : PRINT #0,'Bad line.'
2420     = REMAINDER : PRINT #0,'Error code ';error_value
2430   END SELect
2440 END DEFine REPORT_AN_ERROR
